--Soaring, by Epikas Jones, formally ImortalTJones--

jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
--trackWidth = skinvars["trackwidth"]
trackWidth = 11.5 
fullsteep = jumping or skinvars.prefersteep

SetScene{
	glowpasses = ifhifi(4,0),
	glowspread = ifhifi(0.5,0),
	radialblur_strength = 1.5,
	dynamicFOV = false,
	FOV = 65,
	watertint = {r=255,g=255,b=255,a=30},
	ambientlight = {255,240,227},
	minwaterrandomdarkness = 100,
	watertexture = "cloudwater.png",
	watertype = 2,
	towropes = jumping,
	airdebris_count = ifhifi(5000,100),
	airdebris_density = ifhifi(50,2),
	airdebris_particlesize = fif(jumping, 0.3, 0.55),
	airdebris_fieldsize = 450,
	airdebris_layer = 13,
	useblackgrid=false,
	jumping=false,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep, 1, .7)},
}
	CreateLight{
		type= "directional",
		railoffset = -1,
		range = 10,
		intensity = .7,
		transform = {
			position={0,2,0}, rotation={.4,346.2,0}
		},
		color={255,255,255}
	}

	SetBlocks{
	    allow_mod_block_scaling = false,
		colorblocks={
			mesh = "Balloon.obj",
			shader = "RimLightHatchedSurferExternal",
			texture = "colorblocktex.png",
		    height = -.7,
		    float_on_water = false,
		    scale = {1.3,1.3,1.3},
		},
		greyblocks={
			mesh = "Missle.obj",
			shader = "RimLightHatchedSurferExternal",
			texture = "Missle.png",
			height = -.7,
			float_on_water = false,
			scale = {1.4,1.4,1.4}
		}
	}

CreateRepeatedMeshRail{
    ahead_renderdist = 700,
    behind_renderdist = 100,
    spacing = 45, 
    buildlive = true,
    maxmeshesperbatch = 4,
    calculatenormals = true,
    
	gameobject={
		name="Road Decor",
		shadowcaster = false,
		shadowreceiver = false,
		mesh="Road Decor.obj",
		layer=13,
		shader="VertexColorUnlitTintedAlpha",
		renderqueue=3001,
		shadercolors={
			_Color={255,255,255,175},
		},
		texture="Road Decor.png"
	}
}

SetRings{
	texture="Rings.png",
	shader="VertexColorUnlitTintedAddSmooth",
	layer = 13,
	size=24.5,
	percentringed=.2,
	airtexture="Rings.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=50
}

SetBlockFlashes{
	texture="grey.png",
	sizescaler = 0,
	sizescaler_missed = 0
}

CreateObject{
	gameobject={
		name="CityLights",
		pos={x=0,y=0,z=0},
		mesh="CityLights.obj",
		renderqueue=1000,
		layer=ifhifi(18,13),
		shader="VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={r=200,g=200,b=200}
		},
		texture="White.png",
		scale = {x=1.2,y=1.2,z=1.2},
	}
}

CreateObject{
	name="EndPortal",
	tracknode="end",
	gameobject={
	    scale = {x=35,y=35,z=35},
		mesh="EndPortal.obj",
		renderqueue=1000,
		flatten=false,
		layer=ifhifi(13,13),
		shader="RimLightHatchedSurferExternal",
		shadercolors={
			_Color="highway"
		},
		texture="EndTex.png"
	}
}

	SetSkybox{
		sky={
		    showsun = false,
			month=1,
			hour=11,
			minute=0,
			longitude=184.5,175,
			cloudmaxheight=2.9,
			cloudminheight=-1.0,
			clouddensity=fif(hifi,0.6,0),
			cirrusposition=0,
			useProceduralAmbientLight = false,
			useProceduralSunLight = false
		}
	}

SetTrackColors{
    {r=20, g=20, b=180},
    {r=77, g=200, b=208},
    {r=75, g=180, b=73},
    {r=130, g=130, b=70},
	{r=255, g=255, b=0},
	{r=90, g=150, b=255}
}
SetBlockColors{
    {r=20, g=20, b=180},
    {r=77, g=200, b=208},
    {r=75, g=180, b=73},
    {r=130, g=130, b=70},
	{r=255, g=255, b=0},
	{r=90, g=150, b=255}
}

wakeHeight = 2.5
if jumping then wakeHeight=2.5 else wakeHeight = 0 end
SetWake{
	height = wakeHeight,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 18,
	bottomcolor = {r=255,g=255,b=255},
	topcolor = {r=145,g=195,b=255},
	extraspray = false
}

CreateObject{
	name="DubaiTower",
	gameobject={
		pos={x=0,y=0,z=-1.5},
		mesh="tower.obj",
		shader="Unlit/Texture",
		texture="towermain.png",
		layer=13,
		renderqueue=2000,
		scale = {x=1,y=1,z=1}
	}
}

track = GetTrack()
if buildingNodes == nil then
	buildingNodes = {}
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if i%80==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end
	end

	BatchRenderEveryFrame{prefabName="DubaiTower",
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=100,
                    		maxDistanceShown=30000,
							offsets=offsets,
							collisionLayer = 1,
							testAndHideIfCollideWithTrack=true
						}
end

	SetPlayer{
		cameramode = "third",

		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
		camthird={
			pos={0,5.5,-6},
			rot={29,0,0},
			strafefactor = 0.75,
			strafefactorFar = .75,
			pos2={0,5,-4},
			rot2={29,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.65,
			puzzleoffset2=-1.5},
			
		vehicle={
			min_hover_height= 0.13,
			max_hover_height = 0.23,
			use_water_rooster = true,
			roostercolor = {9,9,18,255},
			water_rooster_z_offset = -.81,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=1.7,z=0},
			calculatenormals=true,
			mesh = "Ship.obj",
			shader="VertexColorUnlitTinted",
			shadercolors={
				_Color = {colorsource="highwayinverted", scaletype="intensity", minscaler=1, maxscaler=2},
				
				},
			texture="ShipMain.png",
			scale = {x=.8,y=.8,z=.8},
			thrusters = {crossSectionShape={{0.05,0.103,0},{-0.05,0.103,0},{-0.119,0,0},{-0.05,-0.103,0},{0.05,-0.103,0},{0.119,0,0}},
						perShapeNodeColorScalers={.5,1.5,1,1.5,1,1.5,.5},
						extrusions=22,
						stretch=-0.1191,
						updateseconds = 0.025,
						instances={
							{pos={0,.9,-1.9},rot={0,0,0.713},scale={1,1,1}},
						}}
		}
	}

auroraExtent = ifhifi(60, 40)
CreateRail{--left aurora
	positionOffset={
		x=-12,
		y=4},
	crossSectionShape={
		{x=-auroraExtent,y=1.5},
		{x=-11,y=.5},
		{x=-11,y=-.5},
		{x=-auroraExtent,y=-1.5}},
	perShapeNodeColorScalers={
		0,
		.4,
		.4,
		0},
	colorMode="aurora",
	color = {r=255,g=255,b=255},
	flatten=false,
	fullfuture = true,
    layer=11,
	texture="White.png",
	renderqueue=2999,
	shader="VertexColorUnlitTintedAddSmooth"
}

CreateRail{--right aurora
	positionOffset={
		x=12,
		y=4},
	crossSectionShape={
		{x=11,y=.5},
		{x=auroraExtent,y=1.5},
		{x=auroraExtent,y=-1.5},
		{x=11,y=-.5}},
	perShapeNodeColorScalers={
		.4,
		0,
		0,
		.4},
	colorMode="aurora",
	color = {r=255,g=255,b=255},
	flatten=false,
	fullfuture = true,
    layer=11,
	renderqueue=2999,
	texture="White.png",
	shader="VertexColorUnlitTintedAddSmooth"
}

CreateRail{--right rail
	positionOffset={
		x=trackWidth + .1,
		y=0},
	crossSectionShape={
		{x=-.65,y=1.5},
		{x=.3,y=1.5},
		{x=.3,y=-0.5},
		{x=-.65,y=-0.5}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="highway",
	renderqueue=fif(hifi,3000,3997),
	color =fif(hifi,{r=255,g=255,b=255},{r=255,g=255,b=255,a=75}),
	flatten=false,
	fullfuture = true,
	stretch = 1,
	texture="white.png",
	shader=fif(hifi,"VertexColorUnlitTintedAddSmoothNoCull","VertexColorUnlitTintedAlpha"),
	shadercolors={_Color={r=0,g=0,b=0}},
	shadersettings={_StartDistance=3.92, _FullDistance=12.9}
}

CreateRail{--right rail outer
	positionOffset={
		x= 21,
		y=4},
	crossSectionShape={
		{x=-.7,y=1.2},
		{x=.7,y=1.2},
		{x=-.85,y=-0.4},
		{x=.7,y=-0.4}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="static",
	color = {r=255,g=255,b=255,a=190},
	flatten=false,
	fullfuture = true,
	stretch = 1,
	texture="white.png",
	renderqueue=3000,
	shader="VertexColorUnlitTintedAlpha",

}

CreateRail{--Left rail
	positionOffset={
		x=-trackWidth - .1,
		y=0},
	crossSectionShape={
		{x=-.65,y=1.5},
		{x=.3,y=1.5},
		{x=.3,y=-0.5},
		{x=-.65,y=-0.5}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="highway",
	renderqueue=fif(hifi,3000,3997),
	color =fif(hifi,{r=255,g=255,b=255},{r=255,g=255,b=255,a=75}),
	flatten=false,
	fullfuture = true,
	stretch = 1,
	texture="white.png",
	shader=fif(hifi,"VertexColorUnlitTintedAddSmoothNoCull","VertexColorUnlitTintedAlpha"),
	shadercolors={_Color={r=0,g=0,b=0}},
	shadersettings={_StartDistance=3.92, _FullDistance=12.9}
}

CreateRail{--left rail outer
	positionOffset={
		x= -21,
		y=4},
	crossSectionShape={
		{x=-.7,y=1.2},
		{x=.7,y=1.2},
		{x=.7,y=-0.4},
		{x=-.85,y=-0.4}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="static",
	color = {r=255,g=255,b=255,a=190},
	flatten=false,
	fullfuture = true,
	stretch = 1,
	texture="white.png",
	renderqueue=3000,
	shader="VertexColorUnlitTintedAlpha",
}
		CreateRail{--Floor Top
		positionOffset={
			x=-0,
			y=-4},
		crossSectionShape={
			{x=-19.934,y=8.026},
			{x=-14.324,y=5.28},
			{x=-7.339,y=0.703},
			{x=0,y=0},
			{x=7.339,y=0.703},
			{x=14.324,y=5.28},
			{x=19.934,y=8.026}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {r=0,g=0,b=200,a=85},
		flatten=false,
		wrapnodeshape=false,
		fullfuture = true,
		stretch = 1,
		renderqueue=2000,
		shader="VertexColorUnlitTintedAlpha"
}

	CreateRail{--Floor Mid
		positionOffset={
			x=-0,
			y=-6},
		crossSectionShape={
			{x=-19.934,y=8.026},
			{x=-14.324,y=5.28},
			{x=-7.339,y=0.703},
			{x=0,y=0},
			{x=7.339,y=0.703},
			{x=14.324,y=5.28},
			{x=19.934,y=8.026}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {r=0,g=0,b=200,a=50},
		flatten=false,
		wrapnodeshape=false,
		fullfuture = true,
		stretch = 1,
		renderqueue=2000,
		shader="VertexColorUnlitTintedAlpha"
}
	
		CreateRail{--Floor Bot
		positionOffset={
			x=-0,
			y=-8},
		crossSectionShape={
			{x=-19.934,y=8.026},
			{x=-14.324,y=5.28},
			{x=-7.339,y=0.703},
			{x=0,y=0},
			{x=7.339,y=0.703},
			{x=14.324,y=5.28},
			{x=19.934,y=8.026}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {r=255,g=198,b=-0,a=15},
		flatten=false,
		wrapnodeshape=false,
		fullfuture = true,
		stretch = 1,
		renderqueue=2000,
		shader="VertexColorUnlitTintedAlpha"
}
