jumping = PlayerCanJump()

quality = GetQualityLevel() -- GetQualityLevel returns 1,2,or 3
hifi = quality > 2
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

function lowMedHigh(if_low, if_med, if_high)
	if quality <= 1 then return if_low
	elseif quality == 2 then return if_med
	else return if_high end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
fullsteep = jumping or skinvars.prefersteep

SetScene{
	glowpasses = 0,
	glowspread = 0,
	radialblur_strength = 0,
	dynamicFOV = false,
	use_intro_swoop_cam = false,
	water = false,
	towropes = false,--use the tow ropes if jumping
	useblackgrid=false,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep, 1, .9)},
	airdebris_count = ifhifi(20000,500),
	airdebris_flashsizescaler = .2,
	airdebris_density = 100,
	airdebris_texture = "bubbles.png",
	airdebris_layer = 12,
	hide_default_background_verticals = true,
}

SetBlockFlashes{
	sizescaler=0,
	sizescaler_missed = 0
}

AddPostEffect{
		depth= "foreground",
		builtin={
			name="AmplifyColor",
			--lut = "LUT'S/HDR.png"
			lut = "robot action.png"
			--BlendAmount = 1,
			--LutBlendTexture = "LUT'S/vibrance 2.png",
			--Masktexture = "LUT'S/Mask.png"

		}
	}
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,2.5,-1},
			rot={20,0,0}},
		camthird={
			pos={0,2,-2},
			rot={20,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = false,
			rollscaler = -1,
			panscaler = .1,
			pos={x=0,y=0,z=2.6},
			mesh="matau_swim.obj",
			shader = "VertexColorUnlitTinted",
			layer = 14,
			renderqueue = 2000,

			texture="matau.jpg",
			scale = {x=1,y=1,z=1},
		}
	}
		SetBlocks{
		allow_mod_block_scaling = false,
		colorblocks={
			mesh = "disk.obj",
			shader = fif(ispuzzle, "Diffuse", "VertexColorUnlitTinted"),
			texture = "le_disk.jpg",
		    height = -1.2,
		    float_on_water = false,
		    scale = {1,1,1}
		},
		greyblocks={
			mesh = "cargo.obj",
			shader = "VertexColorUnlitTinted",
			texture = "cargo.jpg",
		},
		powerups={
		whiteblock={mesh = "disk.obj",
			shader = "VertexColorUnlitTinted",
			texture = "dot.jpg"},
			ghost={mesh = "disk.obj",
			shader = "VertexColorUnlitTinted",
			texture = "dot.jpg"},
			powerpellet={mesh = "disk.obj",
			shader = "VertexColorUnlitTinted",
			texture = "dot.jpg"}
		}
	}
SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
	color = {r=255,g=255,b=255,a=0},
	skysphere="chute.jpg"
}


CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	visible=false,
	gameobject={
		pos={x=0,y=-100,z=0},
		mesh="tower.obj",
		shadowcaster = false,
		shadowreceiver = false,
		shader = "VertexColorUnlitTinted",
		texture="building1.jpg",
		--diffuseinair = true,
		layer = 12,
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
		},
		--texture="White.png",
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}


track = GetTrack()--get the track data from the game engine

if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	for i=1,#track do
		if (i+40)%200==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end

		
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=10,
                    		maxDistanceShown=20000,
							offsets=offsets,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}
end


CreateObject{
	name="EndCookie",
	tracknode="end",
	gameobject={
		-- transform={pos={0,0,126}}, scale={scaletype="intensity",min={55,99,900},max={66,120,900}}},
		mesh="lemetru_station.obj",
		shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
		--diffuseinair = true,
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
		},
		}
	}


SetTrackColors{
    {250,250,250}
}
SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="Bits.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAddSmoothNoDepth",
	size=0,
	percentringed=.1,
	airtexture="Bits.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16,
}

CreateRepeatedMeshRail{
    ahead_renderdist = 150,
    behind_renderdist = 30,
    spacing = 9.01, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = false, --set true if using lighting
    
	gameobject={
		name="meshrailproto1",
		shadowcaster = false,
		shadowreceiver = false,
		mesh="lemetru_chute.obj",
		shader="FX/Glass/Stained BumpDistort",
			shadersettings={_BumpAmt =15},
			shadercolors={
				_Color = {255,255,255},
				},
			textures={_MainTex="lemetru_chute.png", _BumpMap="1.jpg"},
		colorMode="highway",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},

		}
	}
}
CreateRepeatedMeshRail{
    ahead_renderdist = 500,
    behind_renderdist = 30,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = false, --set true if using lighting
    
	gameobject={
		name="meshrailproto1",
		shadowcaster = false,
		shadowreceiver = false,
		mesh="lemetru_chute_ring.obj",
		shader="VertexColorUnlitTinted",
		colorMode="highway",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
		},
		texture="lemetru_chute_ring.png"
	}
}
--RAILS. rails are the bulk of the graphics in audiosurf. Each one is a 2D shape extruded down the length of the track.

CreateRail{--left aurora core
	positionOffset={
		x=-19,
		y=33},
	crossSectionShape={
		{x=-13,y=.5},
		{x=-9,y=.5},
		{x=-9,y=-.5},
		{x=-13,y=-.5}},
	perShapeNodeColorScalers={
		1,
		1,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="building.jpg",
	shader="VertexColorUnlitTinted"
}

CreateRail{--right aurora core
	positionOffset={
		x=19,
		y=33},
	crossSectionShape={
		{x=9,y=.5},
		{x=13,y=.5},
		{x=13,y=-.5},
		{x=9,y=-.5}},
	perShapeNodeColorScalers={
		1,
		1,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="building.jpg",
	shader="VertexColorUnlitTinted"
}
CreateRail{--left aurora core
	positionOffset={
		x=-19,
		y=-33},
	crossSectionShape={
		{x=-13,y=.5},
		{x=-9,y=.5},
		{x=-9,y=-.5},
		{x=-13,y=-.5}},
	perShapeNodeColorScalers={
		1,
		1,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="building.jpg",
	shader="VertexColorUnlitTinted"
}

CreateRail{--right aurora core
	positionOffset={
		x=19,
		y=-33},
	crossSectionShape={
		{x=9,y=.5},
		{x=13,y=.5},
		{x=13,y=-.5},
		{x=9,y=-.5}},
	perShapeNodeColorScalers={
		1,
		1,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="building.jpg",
	shader="VertexColorUnlitTinted"
}
CreateRail{
	positionOffset={
		x=.2,
		y=-5},
	crossSectionShape={
		{x=-2,y=.5},
		{x=2,y=.5},
	},
	perShapeNodeColorScalers={
		0,
		0},
	colorMode="static",
	color = {r=251,g=251,b=223},
	flatten=true,
	texture="White1.png",
	shader="DiffuseVertexColored",
}