---Nautilus by Dj Pavlusha---


jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
	radialBlurEffect = BuildMaterial{ -- background radial blur (seen mostly on star air debris trails)
		shader="PostRadialBlur",
		shadersettings={_Amount=.02, _Center={.5,.5,0}}
	}

	AddPostEffect{
		depth="background",
		material = radialBlurEffect
	}
SetScene{
	glowpasses = ifhifi(0,0),
	glowspread = ifhifi(0,0),
	radialblur_strength = 1,
	watertype = 0,
	use_intro_swoop_cam = false,
	water = false,
	watertint = {r=250,g=250,b=250,a=30},
	watertexture = "White.png",
	towropes = false,
	airdebris_count = ifhifi(1,1),
	airdebris_density = ifhifi(1,1),
	usedefaultrails=false,
	useblackgrid=true,
	fullfuture = true,
	airdebris_count = ifhifi(20000,500),
	airdebris_flashsizescaler = .15,
	airdebris_density = 100,
	airdebris_texture = "bubbles.png",
	airdebris_layer = 12,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep,1,.65)}
}
AddPostEffect{
		depth= "foreground",
		builtin={
			name="AmplifyColor",
			--lut = "LUT'S/HDR.png"
			lut = "robot action.png"
			--BlendAmount = 1,
			--LutBlendTexture = "LUT'S/vibrance 2.png",
			--Masktexture = "LUT'S/Mask.png"

		}
	}
	SetBlocks{
	allow_mod_block_scaling = false,
		colorblocks={
			mesh = "22.obj",
			shader = fif(ispuzzle, "Diffuse", "RimLight"),
			texture = "White.png",
		    height = 0,
		    float_on_water = false,
		    scale = {1,1,1}
		},
		greyblocks={
			mesh = "3.obj",
			shader = "RimLight",
			texture = "black.png"},
		powerups={
			ghost={mesh = "333.obj",
			shader = "RimLight",
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture = "White.png"},
			whiteblock={mesh = "333.obj",
			shader = "RimLight",
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture = "White.png"},
			powerpellet={mesh = "1.obj",
			shader = "RimLight",
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture = "White.png"}
		}
	}
	
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,2.5,-1},
			rot={20,0,0}},
		camthird={
			pos={0,2,-2},
			rot={20,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = false,
			rollscaler = -1,
			panscaler = .08,
			pos={x=0,y=0,z=-0.5},
			mesh="111.obj",
			shader = "RimLightHatchedSurferExternal",
			layer = 14,
			renderqueue = 2000,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture="White.png",
			scale = {x=0.9,y=0.9,z=0.9},
		}
	}


SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
	custom={
		_FrontTex ="1.jpg",
		_BackTex ="2.jpg",
		_RightTex ="3.jpg",
		_LeftTex ="4.jpg",
		_UpTex ="5.jpg",
		_DownTex ="6.jpg"
	},
	color={r=130,g=130,b=130,a=0}
}

SetBlockFlashes{
	texture="Black.png"
}

SetTrackColors{
    {r=0, g=191, b=240},
	{r=0, g=50, b=70}
}
SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}
SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	
				texture = "r1.png",
                shader="VertexColorUnlitTintedAddSmooth",
	layer = 15, 
	size=0, --22
	percentringed=.1,--ifhifi(2,.01),-- .2,
	airtexture="r1.png",
	airshader="VertexColorUnlitTintedAddSmooth",
	airsize=0
}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="BlueWhale.obj",
		shader="VertexColorUnlitTinted",
		shadercolors={
			_Color={255,255,255}},
		texture="BlueWhale.png",
		scale = {x=1000,y=1000,z=1000}
	}
}

--[[CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMeToo",
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="345.obj",
		shader="RimLightHatchedSurferExternal",
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		},
		texture="White.png",
		scale = {x=1,y=1,z=1}
	}
}]]

track = GetTrack()--get the track data from the game engine

if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	for i=1,#track do
		if i%80==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end

	--[[	if (i+40)%120==0 then
			buildingNodesToo[#buildingNodesToo+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsetsToo[#offsetsToo+1] = {xOffset,-100,0}
		end]]
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=true,
                    		maxShown=10,
                    		maxDistanceShown=20000,
							offsets=offsets,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}

	--[[BatchRenderEveryFrame{prefabName="BuildingCloneMeToo", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodesToo,
                    		rotateWithTrack=true,
                    		maxShown=10,
                    		maxDistanceShown=20000,
							offsets=offsetsToo,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}]]
end
CreateObject{
	name="lvf",
	railoffset=0,
	--floatonwaterwaves = false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="222.obj",
		--layer=10,
		shader="FX/Glass/Stained BumpDistort",
			shadersettings={_BumpAmt =15},
			shadercolors={
				_Color = {255,255,255},
				},
			textures={_MainTex="White.png", _BumpMap="7.jpg"},
		colorMode="none",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={255,255,255},

		},
		scale = {x=3,y=3,z=3}
	}
}
SetWake{
	height = 0,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 13,
	bottomcolor = {r=175,g=175,b=175},
	topcolor = "highway"
}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="zzzap",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="clock.obj",
		--shadowcaster=true,
		--layer = iflofi(13,18),
		shader="VertexColorUnlitTintedAddSmooth",
		shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
		texture="r1.png",
		scale = {x=.45,y=.45,z=1}
	}
}
Nodes_Zone2 = {}
RotationSpeeds_Zone = {}
RotationSpeeds_Zone6 = {}
for i=1,#track do
			if track[i].intensity > 0.85 then
			Nodes_Zone2[#Nodes_Zone2+1] = i 
			RotationSpeeds_Zone[#RotationSpeeds_Zone+1] = {0,0,-100}
				RotationSpeeds_Zone6[#RotationSpeeds_Zone6+1] = {0,0,100}
				end
			end
BatchRenderEveryFrame{
	prefabName="zzzap", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = Scales,
	rotationspeeds = RotationSpeeds_Zone6,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 3,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
BatchRenderEveryFrame{
	prefabName="zzzap", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = Scales,
	rotationspeeds = RotationSpeeds_Zone,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 2,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}