jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]

SetScene{
	glowpasses = ifhifi(0,0),
	glowspread = ifhifi(0,0),
	radialblur_strength = 1,
	watertype = 0,
	water = jumping,
	watertint = {r=250,g=250,b=250,a=30},
	watertexture = "WaterCubesBlue_BlackTop_WhiteLowerTier.png",
	towropes = jumping,
	airdebris_count = ifhifi(1,1),
	airdebris_density = ifhifi(1,1),
	usedefaultrails=false,
	useblackgrid=false,
	fullfuture = true,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep,1,.65)}
}

if not jumping then
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,2.5,-1},
			rot={20,0,0}},
		camthird={
			pos={0,2,-2},
			rot={20,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=1.8},
			mesh="2.obj",
			shader = "VertexColorUnlitTinted",
			layer = 14,
			renderqueue = 2000,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture="white.png",
			scale = {x=1,y=1,z=1},
		}
	}
end

if jumping then
	
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,3,-1},
			rot={30,0,0}},
		camthird={
			pos={0,2.5,-3},
			rot={10,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},
			mesh="2.obj",
			shader="VertexColorUnlitTinted",
			layer = 14,
			renderqueue = 2000,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture="white.png",
			scale = {x=1,y=1,z=1},
		}
	}
end

SetBlocks{
	colorblocks={
		mesh = "9.obj",
		shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		texture = "White.png",
		scale = {1,1,1}
	},
	powerups={
		ghost={
			mesh = "Color.obj",
			shader = "MatCap/Vertex/PlainBright",
			shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
			texture = "White.png",
			scale = {1,1,1},
			shadercolors = {_Color="highway"}
		},
		powerpellet={
			mesh = "Color.obj",
			shader = "MatCap/Vertex/PlainBright",
			shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
			texture = "White.png",
			scale = {1,1,1},
			shadercolors = {_Color="highway"}
		}
	}
}

SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
	skysphere="1.jpg"
}


SetBlockFlashes{
	texture="Black.png"
}

SetTrackColors{
    {r=0, g=0, b=0},
    {r=0, g=0, b=0},
    {r=0, g=0, b=0},
    {r=0, g=0, b=0},
	{r=0, g=0, b=0}
}

SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="PlainRing_1024.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAlpha2",
	size=66,
	percentringed=ifhifi(.50, .90),
	airtexture="transparent.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16
}

wakeHeight = 2
if jumping then wakeHeight=2 else wakeHeight = 0 end
SetWake{
	height = wakeHeight,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 13,
	bottomcolor = {r=175,g=175,b=175},
	topcolor = "highway"
}