// 2014 DeathByNukes

Shader "ring_2spin_AddSmooth" {
Properties {
	_MainTex ("Base (RGB)", 2D) = "white" {}
	_SpinSpeed ("Clockwise Spin Speed (radians per second)", float) = 6.283185
	_MainTex2 ("Base 2 (RGB)", 2D) = "white" {}
	_SpinSpeed2 ("Clockwise Spin Speed 2", float) = -6.283185
	//_TestTime ("time", float) = 1.0
}

SubShader {
	Tags {"Queue" = "Transparent" }
	Pass {
		ZWrite Off
		ColorMask RGB
		Fog { Mode Off }
		Blend One OneMinusSrcColor
		AlphaTest Greater 0.01
		Program "vp" {
// Vertex combos: 1
//   opengl - ALU: 54 to 54
//   d3d9 - ALU: 46 to 46
//   d3d11 - ALU: 14 to 14, TEX: 0 to 0, FLOW: 1 to 1
//   d3d11_9x - ALU: 14 to 14, TEX: 0 to 0, FLOW: 1 to 1
SubProgram "opengl " {
Keywords { }
Bind "vertex" Vertex
Bind "color" Color
Bind "texcoord" TexCoord0
Vector 5 [_Time]
Float 6 [_SpinSpeed]
Float 7 [_SpinSpeed2]
"!!ARBvp1.0
# 54 ALU
PARAM c[11] = { { -24.980801, 60.145809, 0.15915491, 0.5 },
		state.matrix.mvp,
		program.local[5..7],
		{ 0.25, 0.5, 0.75, 1 },
		{ -85.453789, 64.939346, -19.73921, 1 },
		{ 1, -1 } };
TEMP R0;
TEMP R1;
TEMP R2;
TEMP R3;
TEMP R4;
TEMP R5;
MOV R0.x, c[7];
MUL R0.x, R0, c[5].y;
MUL R0.x, R0, c[0].z;
FRC R2.z, R0.x;
SLT R1, R2.z, c[8];
ADD R0.xyz, R1.yzww, -R1;
MOV R1.yzw, R0.xxyz;
MOV R0.w, c[6].x;
MUL R0.w, R0, c[5].y;
MUL R0.w, R0, c[0].z;
DP4 R2.y, R1, c[8].xxzz;
DP3 R2.x, R0, c[8].yyww;
FRC R2.w, R0;
ADD R3.xy, R2.z, -R2;
SLT R0, R2.w, c[8];
ADD R2.xyz, R0.yzww, -R0;
MUL R5.xy, R3, R3;
MOV R0.yzw, R2.xxyz;
DP4 R3.y, R0, c[8].xxzz;
DP3 R3.x, R2, c[8].yyww;
ADD R2.xy, R2.w, -R3;
MUL R4.xy, R2, R2;
MUL R5.zw, R5.xyxy, R5.xyxy;
MUL R2, R5.zzww, c[0].xyxy;
ADD R3, R2, c[9].xyxy;
MAD R3, R3, R5.zzww, c[9].zwzw;
MAD R3.xy, R3.xzzw, R5, R3.ywzw;
MUL R4.zw, R4.xyxy, R4.xyxy;
MUL R2, R4.zzww, c[0].xyxy;
ADD R2, R2, c[9].xyxy;
MAD R2, R2, R4.zzww, c[9].zwzw;
DP4 R3.w, R1, c[10].xxyy;
DP4 R3.z, R1, c[10].xyyx;
DP4 R1.w, R0, c[10].xxyy;
DP4 R1.z, R0, c[10].xyyx;
MAD R2.xy, R2.xzzw, R4, R2.ywzw;
MUL R1.zw, R1, R2.xyxy;
ADD R0.xy, vertex.texcoord[0], -c[0].w;
MUL R2.xy, R0.y, R1.wzzw;
MUL R1.xy, R3.zwzw, R3;
MOV R0.z, R1;
MOV R0.w, -R1;
MAD R1.zw, R0.x, R0, R2.xyxy;
MOV R0.z, R1.x;
MUL R2.xy, R0.y, R1.yxzw;
MOV R0.w, -R1.y;
MAD R0.xy, R0.x, R0.zwzw, R2;
ADD result.texcoord[0].xy, R1.zwzw, c[0].w;
ADD result.texcoord[1].xy, R0, c[0].w;
MOV result.color, vertex.color;
DP4 result.position.w, vertex.position, c[4];
DP4 result.position.z, vertex.position, c[3];
DP4 result.position.y, vertex.position, c[2];
DP4 result.position.x, vertex.position, c[1];
END
# 54 instructions, 6 R-regs
"
}

SubProgram "d3d9 " {
Keywords { }
Bind "vertex" Vertex
Bind "color" Color
Bind "texcoord" TexCoord0
Matrix 0 [glstate_matrix_mvp]
Vector 4 [_Time]
Float 5 [_SpinSpeed]
Float 6 [_SpinSpeed2]
"vs_2_0
; 46 ALU
def c7, -0.50000000, 0.15915491, 0.50000000, 0
def c8, 6.28318501, -3.14159298, 0, 0
def c9, -0.00000155, -0.00002170, 0.00260417, 0.00026042
def c10, -0.02083333, -0.12500000, 1.00000000, 0.50000000
dcl_position0 v0
dcl_color0 v1
dcl_texcoord0 v2
mov r0.y, c4
mov r0.x, c4.y
mul r0.y, c6.x, r0
mul r0.x, c5, r0
mad r0.y, -r0, c7, c7.z
frc r0.y, r0
mad r0.x, -r0, c7.y, c7.z
frc r0.x, r0
mad r1.x, r0.y, c8, c8.y
mad r2.x, r0, c8, c8.y
sincos r0.xy, r1.x, c9.xyzw, c10.xyzw
sincos r1.xy, r2.x, c9.xyzw, c10.xyzw
add r0.zw, v2.xyxy, c7.x
mov r1.z, r1.x
mul r2.xy, r0.w, r1.yxzw
mov r1.w, -r1.y
mad r1.xy, r0.z, r1.zwzw, r2
mov r1.z, r0.x
mul r2.xy, r0.w, r0.yxzw
mov r1.w, -r0.y
mad r0.xy, r0.z, r1.zwzw, r2
add oT0.xy, r1, c7.z
add oT1.xy, r0, c7.z
mov oD0, v1
dp4 oPos.w, v0, c3
dp4 oPos.z, v0, c2
dp4 oPos.y, v0, c1
dp4 oPos.x, v0, c0
"
}

SubProgram "d3d11 " {
Keywords { }
Bind "vertex" Vertex
Bind "color" Color
Bind "texcoord" TexCoord0
ConstBuffer "$Globals" 32 // 24 used size, 3 vars
Float 16 [_SpinSpeed]
Float 20 [_SpinSpeed2]
ConstBuffer "UnityPerCamera" 128 // 16 used size, 8 vars
Vector 0 [_Time] 4
ConstBuffer "UnityPerDraw" 336 // 64 used size, 6 vars
Matrix 0 [glstate_matrix_mvp] 4
BindCB "$Globals" 0
BindCB "UnityPerCamera" 1
BindCB "UnityPerDraw" 2
// 22 instructions, 5 temp regs, 0 temp arrays:
// ALU 14 float, 0 int, 0 uint
// TEX 0 (0 load, 0 comp, 0 bias, 0 grad)
// FLOW 1 static, 0 dynamic
"vs_4_0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"
}

SubProgram "d3d11_9x " {
Keywords { }
Bind "vertex" Vertex
Bind "color" Color
Bind "texcoord" TexCoord0
ConstBuffer "$Globals" 32 // 24 used size, 3 vars
Float 16 [_SpinSpeed]
Float 20 [_SpinSpeed2]
ConstBuffer "UnityPerCamera" 128 // 16 used size, 8 vars
Vector 0 [_Time] 4
ConstBuffer "UnityPerDraw" 336 // 64 used size, 6 vars
Matrix 0 [glstate_matrix_mvp] 4
BindCB "$Globals" 0
BindCB "UnityPerCamera" 1
BindCB "UnityPerDraw" 2
// 22 instructions, 5 temp regs, 0 temp arrays:
// ALU 14 float, 0 int, 0 uint
// TEX 0 (0 load, 0 comp, 0 bias, 0 grad)
// FLOW 1 static, 0 dynamic
"vs_4_0_level_9_1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"
}

}
Program "fp" {
// Fragment combos: 1
//   opengl - ALU: 8 to 8, TEX: 2 to 2
//   d3d9 - ALU: 7 to 7, TEX: 2 to 2
//   d3d11 - ALU: 4 to 4, TEX: 2 to 2, FLOW: 1 to 1
//   d3d11_9x - ALU: 4 to 4, TEX: 2 to 2, FLOW: 1 to 1
SubProgram "opengl " {
Keywords { }
SetTexture 0 [_MainTex] 2D
SetTexture 1 [_MainTex2] 2D
"!!ARBfp1.0
# 8 ALU, 2 TEX
PARAM c[1] = { { 1 } };
TEMP R0;
TEMP R1;
MOV_SAT R0.zw, fragment.texcoord[1].xyxy;
MOV_SAT R0.xy, fragment.texcoord[0];
TEX R1, R0.zwzw, texture[1], 2D;
TEX R0, R0, texture[0], 2D;
ADD R1, -R1, c[0].x;
ADD R0, -R0, c[0].x;
MAD R0, -R0, R1, c[0].x;
MUL result.color, R0, fragment.color.primary;
END
# 8 instructions, 2 R-regs
"
}

SubProgram "d3d9 " {
Keywords { }
SetTexture 0 [_MainTex] 2D
SetTexture 1 [_MainTex2] 2D
"ps_2_0
; 7 ALU, 2 TEX
dcl_2d s0
dcl_2d s1
def c0, 1.00000000, 0, 0, 0
dcl v0
dcl t0.xy
dcl t1.xy
mov_sat r0.xy, t1
mov_sat r1.xy, t0
texld r0, r0, s1
texld r1, r1, s0
add r0, -r0, c0.x
add r1, -r1, c0.x
mad r0, -r1, r0, c0.x
mul r0, r0, v0
mov_pp oC0, r0
"
}

SubProgram "d3d11 " {
Keywords { }
SetTexture 0 [_MainTex] 2D 0
SetTexture 1 [_MainTex2] 2D 1
// 8 instructions, 2 temp regs, 0 temp arrays:
// ALU 4 float, 0 int, 0 uint
// TEX 2 (0 load, 0 comp, 0 bias, 0 grad)
// FLOW 1 static, 0 dynamic
"ps_4_0
eefiecedojmoggajbinoljmifjmlelillfdakjjoabaaaaaaheacaaaaadaaaaaa
cmaaaaaaliaaaaaaomaaaaaaejfdeheoieaaaaaaaeaaaaaaaiaaaaaagiaaaaaa
aaaaaaaaabaaaaaaadaaaaaaaaaaaaaaapaaaaaaheaaaaaaaaaaaaaaaaaaaaaa
adaaaaaaabaaaaaaapapaaaahkaaaaaaaaaaaaaaaaaaaaaaadaaaaaaacaaaaaa
adadaaaahkaaaaaaabaaaaaaaaaaaaaaadaaaaaaacaaaaaaamamaaaafdfgfpfa
epfdejfeejepeoaaedepemepfcaafeeffiedepepfceeaaklepfdeheocmaaaaaa
abaaaaaaaiaaaaaacaaaaaaaaaaaaaaaaaaaaaaaadaaaaaaaaaaaaaaapaaaaaa
fdfgfpfegbhcghgfheaaklklfdeieefciaabaaaaeaaaaaaagaaaaaaafkaaaaad
aagabaaaaaaaaaaafkaaaaadaagabaaaabaaaaaafibiaaaeaahabaaaaaaaaaaa
ffffaaaafibiaaaeaahabaaaabaaaaaaffffaaaagcbaaaadpcbabaaaabaaaaaa
gcbaaaaddcbabaaaacaaaaaagcbaaaadmcbabaaaacaaaaaagfaaaaadpccabaaa
aaaaaaaagiaaaaacacaaaaaadgcaaaafpcaabaaaaaaaaaaaegbobaaaacaaaaaa
efaaaaajpcaabaaaabaaaaaaegaabaaaaaaaaaaaeghobaaaaaaaaaaaaagabaaa
aaaaaaaaefaaaaajpcaabaaaaaaaaaaaogakbaaaaaaaaaaaeghobaaaabaaaaaa
aagabaaaabaaaaaaaaaaaaalpcaabaaaaaaaaaaaegaobaiaebaaaaaaaaaaaaaa
aceaaaaaaaaaiadpaaaaiadpaaaaiadpaaaaiadpaaaaaaalpcaabaaaabaaaaaa
egaobaiaebaaaaaaabaaaaaaaceaaaaaaaaaiadpaaaaiadpaaaaiadpaaaaiadp
dcaaaaanpcaabaaaaaaaaaaaegaobaiaebaaaaaaabaaaaaaegaobaaaaaaaaaaa
aceaaaaaaaaaiadpaaaaiadpaaaaiadpaaaaiadpdiaaaaahpccabaaaaaaaaaaa
egaobaaaaaaaaaaaegbobaaaabaaaaaadoaaaaab"
}

SubProgram "d3d11_9x " {
Keywords { }
SetTexture 0 [_MainTex] 2D 0
SetTexture 1 [_MainTex2] 2D 1
// 8 instructions, 2 temp regs, 0 temp arrays:
// ALU 4 float, 0 int, 0 uint
// TEX 2 (0 load, 0 comp, 0 bias, 0 grad)
// FLOW 1 static, 0 dynamic
"ps_4_0_level_9_1
eefiecedcmbmpadbphnaeckhnmofipjdaolfcgakabaaaaaaieadaaaaaeaaaaaa
daaaaaaadmabaaaameacaaaafaadaaaaebgpgodjaeabaaaaaeabaaaaaaacpppp
niaaaaaacmaaaaaaaaaacmaaaaaacmaaaaaacmaaacaaceaaaaaacmaaaaaaaaaa
abababaaaaacppppfbaaaaafaaaaapkaaaaaiadpaaaaaaaaaaaaaaaaaaaaaaaa
bpaaaaacaaaaaaiaaaaaaplabpaaaaacaaaaaaiaabaaaplabpaaaaacaaaaaaja
aaaiapkabpaaaaacaaaaaajaabaiapkaabaaaaacaaaabdiaabaaoelaabaaaaac
abaabdiaabaabllaecaaaaadaaaaapiaaaaaoeiaaaaioekaecaaaaadabaaapia
abaaoeiaabaioekaacaaaaadaaaaapiaaaaaoeibaaaaaakaacaaaaadabaaapia
abaaoeibaaaaaakaaeaaaaaeaaaaapiaaaaaoeiaabaaoeibaaaaaakaafaaaaad
aaaacpiaaaaaoeiaaaaaoelaabaaaaacaaaicpiaaaaaoeiappppaaaafdeieefc
iaabaaaaeaaaaaaagaaaaaaafkaaaaadaagabaaaaaaaaaaafkaaaaadaagabaaa
abaaaaaafibiaaaeaahabaaaaaaaaaaaffffaaaafibiaaaeaahabaaaabaaaaaa
ffffaaaagcbaaaadpcbabaaaabaaaaaagcbaaaaddcbabaaaacaaaaaagcbaaaad
mcbabaaaacaaaaaagfaaaaadpccabaaaaaaaaaaagiaaaaacacaaaaaadgcaaaaf
pcaabaaaaaaaaaaaegbobaaaacaaaaaaefaaaaajpcaabaaaabaaaaaaegaabaaa
aaaaaaaaeghobaaaaaaaaaaaaagabaaaaaaaaaaaefaaaaajpcaabaaaaaaaaaaa
ogakbaaaaaaaaaaaeghobaaaabaaaaaaaagabaaaabaaaaaaaaaaaaalpcaabaaa
aaaaaaaaegaobaiaebaaaaaaaaaaaaaaaceaaaaaaaaaiadpaaaaiadpaaaaiadp
aaaaiadpaaaaaaalpcaabaaaabaaaaaaegaobaiaebaaaaaaabaaaaaaaceaaaaa
aaaaiadpaaaaiadpaaaaiadpaaaaiadpdcaaaaanpcaabaaaaaaaaaaaegaobaia
ebaaaaaaabaaaaaaegaobaaaaaaaaaaaaceaaaaaaaaaiadpaaaaiadpaaaaiadp
aaaaiadpdiaaaaahpccabaaaaaaaaaaaegaobaaaaaaaaaaaegbobaaaabaaaaaa
doaaaaabejfdeheoieaaaaaaaeaaaaaaaiaaaaaagiaaaaaaaaaaaaaaabaaaaaa
adaaaaaaaaaaaaaaapaaaaaaheaaaaaaaaaaaaaaaaaaaaaaadaaaaaaabaaaaaa
apapaaaahkaaaaaaaaaaaaaaaaaaaaaaadaaaaaaacaaaaaaadadaaaahkaaaaaa
abaaaaaaaaaaaaaaadaaaaaaacaaaaaaamamaaaafdfgfpfaepfdejfeejepeoaa
edepemepfcaafeeffiedepepfceeaaklepfdeheocmaaaaaaabaaaaaaaiaaaaaa
caaaaaaaaaaaaaaaaaaaaaaaadaaaaaaaaaaaaaaapaaaaaafdfgfpfegbhcghgf
heaaklkl"
}

}

#LINE 76

	}
}
}