jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
--trackWidth = fif(jumping, 11.5, 7)
ispuzzle = skinvars.colorcount>1
fullsteep = jumping or skinvars.prefersteep or (not ispuzzle)

SetScene{
	glowpasses = ifhifi(0,0),
	glowspread = ifhifi(0,0),
	radialblur_strength = ifhifi(.75,0), -- foreground radial blur
--	radialblur_strength = fif(jumping,2,0),
	--environment = "city",
	watertype = 2,
	water = false, --only use the water cubes in wakeboard mode
	watertint = {r=255,g=255,b=255,a=234},
	watertexture = "White.png",--texture used to color the dynamic "digital water" surface
	towropes = jumping,--use the tow ropes if jumping
	airdebris_particlesize =0,
	useblackgrid=false,
	hide_default_background_verticals = true,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep,1,.65)} -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}
}

SetBlockFlashes{
	sizescaler=0,
	sizescaler_missed = 0
}

AddPostEffect{
		depth= "foreground",
		builtin={
			name="AmplifyColor",
			--lut = "LUT'S/HDR.png"
			lut = "robot action.png"
			--BlendAmount = 1,
			--LutBlendTexture = "LUT'S/vibrance 2.png",
			--Masktexture = "LUT'S/Mask.png"

		}
	}
if not jumping then
	SetBlocks{
		maxvisiblecount = fif(hifi,200,50),
		colorblocks={
			mesh = "block.obj",
			reflect = false,
			layer = 15,
			--shader = fif(ispuzzle, "Diffuse", "Rim Light"),
			shader = fif(ispuzzle, "Diffuse", "Rim Light"),
			shadersettings={_Brightness=1.42},
			texture = "DoubleLozenge.png",
		    height = 0,
		    float_on_water = false,
		    scale = {1,1,1}
		},
				greyblocks={
			mesh = "Missle.obj",
			shader = "MatCap/Vertex/PlainBright",
				shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5}),
				textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
			--height = -.7,
			float_on_water = false,
			scale = {.8,.8,.8}
		},
		powerups={--override the following objects in case the mod uses them
			powerpellet={
				mesh = "model.obj",
				shader = "MatCap/Vertex/PlainBright",
				shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5}),
				textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
				scale = {1.7,1.7,1.7},
				--reflect = true,
				shadercolors = {_Color="highway", scaletype="intensity", minscaler=2, maxscaler=2.5}
			}}
	}
end

	SetPlayer{
		--showsurfer = false,
		--showboard = false,
		cameramode = "third",
	--	cameramode_air = "first",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
		camthird={
			pos={0,2,-0.5},
			rot={30,0,0},
			strafefactorFar = .75,
			pos2={0,5,-4},
			rot2={30,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.65,
			puzzleoffset2=-1.5},
		vehicle={ --livecoding not supported here
			min_hover_height= 0.23,
			max_hover_height = 0.9,
			use_water_rooster = false,
            smooth_tilting = false,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},
			mesh="raptor.obj",
			--shader="VertexColorUnlitTintedPixelate",
			shader="Rim Light Pixelate",
			--layer = ifhifi(14,15), -- in hifif mode, render it to the topmost only. so the non-pixelated parts don't show through
			layer = 15,
			reflect = false,
			renderqueue = 2000,
			shadersettings={_Scale=3, _Brightness=01},
			shadercolors={
				_RimColor = {43,43,43}},
				textures={_MainTex="f22.png"},
			texture="f22.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						--shader="VertexColorUnlitTinted",
						shader="VertexColorUnlitTintedAddSmooth",
						layer = 14,
						renderqueue = 2999,
						colorscaler = 2,
						extrusions=20,
						stretch=-.4,
						updateseconds = 0.025,
						instances={
							{pos={.08,-.06,-1.297},rot={0,0,58.713},scale={.4,.4,.4}},
							{pos={-.08,-.06,-1.297},rot={0,0,313.7366},scale={.4,.4,.4}}
						}}
		}
	}


SetSkybox{
	skysphere="skyline1.jpg",
	color = {r=255,g=255,b=255,a=0},
	sky={
		month=6,
		hour=48,
		minute=16,
		longitude=185.6,--175,
		cloudmaxheight=1.2,
		clouddensity = 1,
		cloudminheight=-2,
		--cirrusposition=30,
		useProceduralAmbientLight = false,
		useProceduralSunLight = false,
		flare = false, showsun=false
	}
}--end
	
SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
	{r=0, g=0, b=0},
	{r=120, g=120, b=200},
	{r=120, g=120, b=200},
	{r=120, g=120, b=200},
	{r=120, g=120, b=200},
	{r=120, g=120, b=255},
	{r=255, g=150, b=50},
    {r=255, g=50, b=50}
    
}

SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}


--SetBlockColors{ --this is only used for puzzle modes (which you don't have yet) with multiple colors of blocks
--    {r=93, g=8, b=132},
--	{r=1.0, g=0.27, b=0.2},
--    {r=0.047, g=0.5098, b=0.94},
--    {r=1.0, g=0.85, b=0.4157},
--	{r=0, g=0.29, b=0.08},
--    {r=1,g=0,b=0}
--}

if ispuzzle then
	CreateLight{
		type= "directional",
		railoffset = -1,
		range = 10,
		intensity = 1,
		transform = {
			position={0,2,0}, rotation={.4,346.2,0}
		},
		color={255,255,255}
	}
end
radialBlurEffect = BuildMaterial{ -- background radial blur (seen mostly on star air debris trails)
		shader="PostRadialBlur",
		shadersettings={_Amount=.02, _Center={.5,.5,0}}
	}

	AddPostEffect{
		depth="background",
		material = radialBlurEffect
	}
SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	
				texture =  "Bits3.png",
                shader="VertexColorUnlitTintedAddSmooth",
	layer = 15, 
	size=0, --22
	percentringed=.02,--ifhifi(2,.01),-- .2,
	airtexture="grey11.jpg",
	airshader="VertexColorUnlitTintedAddSmooth",
	airsize=0
}
skyUpdateCounter = 0
bang=false
postbang=false
r27=0
function Update(dt)
if dt>0  then
	skyUpdateCounter = skyUpdateCounter + dt
	if(skyUpdateCounter > .08) then--don't update sky colors every frame
	skyUpdateCounter = 0
	r26=math.random(0,500)
	if postbang then
	postbang=false
	SetSkybox{
	skysphere="thunder4.jpg",
sky={
		month=6,
		hour=48,
		minute=16,
		longitude=185.6,--175,
		cloudmaxheight=1.2,
		clouddensity = 1,
		cloudminheight=-2,
		--cirrusposition=30,
		useProceduralAmbientLight = false,
		useProceduralSunLight = false,
		flare = false, showsun=false
	}
	}
	elseif bang then
	bang=false
	postbang=true
		r27=r27+1
		if (r27%3==0) then SetSkybox{
	skysphere="thunder1.jpg",
sky={
		month=6,
		hour=48,
		minute=16,
		longitude=185.6,--175,
		cloudmaxheight=1.2,
		clouddensity = 1,
		cloudminheight=-2,
		--cirrusposition=30,
		useProceduralAmbientLight = false,
		useProceduralSunLight = false,
		flare = false, showsun=false
	}
	}
	elseif (r27%3==1)then
		SetSkybox{
	skysphere="thunder2.jpg",
sky={
		month=6,
		hour=48,
		minute=16,
		longitude=185.6,--175,
		cloudmaxheight=1.2,
		clouddensity = 1,
		cloudminheight=-2,
		--cirrusposition=30,
		useProceduralAmbientLight = false,
		useProceduralSunLight = false,
		flare = false, showsun=false
	}
	}
	else
		SetSkybox{
	skysphere="thunder3.jpg",
sky={
		month=6,
		hour=48,
		minute=16,
		longitude=185.6,--175,
		cloudmaxheight=1.2,
		clouddensity = 1,
		cloudminheight=-2,
		--cirrusposition=30,
		useProceduralAmbientLight = false,
		useProceduralSunLight = false,
		flare = false, showsun=false
	}
	}
	
	end
		elseif (r26>485)then
			r25=math.random(0,5)
			
			if (r25==0) then postbang=true else bang=true end
		SetSkybox{
	skysphere="thunder4.jpg",
sky={
		month=6,
		hour=48,
		minute=16,
		longitude=185.6,--175,
		cloudmaxheight=1.2,
		clouddensity = 1,
		cloudminheight=-2,
		--cirrusposition=30,
		useProceduralAmbientLight = false,
		useProceduralSunLight = false,
		flare = false, showsun=false
	}
	}
	else SetSkybox{
	skysphere="skyline1.jpg",
	color = {r=255,g=255,b=255,a=0},
	sky={
		month=6,
		hour=48,
		minute=16,
		longitude=185.6,--175,
		cloudmaxheight=1.2,
		clouddensity = 1,
		cloudminheight=-2,
		--cirrusposition=30,
		useProceduralAmbientLight = false,
		useProceduralSunLight = false,
		flare = false, showsun=false
	}
	}
end	
	end
	end
end

wakeHeight = 0
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
}

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		pos={x=0,y=-100,z=0},
		--mesh="skyscraper42.obj",
		mesh="skyscraper_withbase.obj",
		--shader="VertexColorUnlitTintedAlpha",
		shader=fif(jumping, "Diffuse", "VertexColorUnlitTinted"),
		diffuseinair = true,
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture=fif(jumping, "White.png", "grey11.jpg"),
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe2",
	gameobject={
		pos={x=0,y=-100,z=0},
		--mesh="skyscraper42.obj",
		mesh="skyscraper_withbase_sqrt.obj",
		--shader="VertexColorUnlitTintedAlpha",
		shader=fif(jumping, "Diffuse", "VertexColorUnlitTinted"),
		diffuseinair = true,
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture=fif(jumping, "White.png", "grey11.jpg"),
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}

track = GetTrack()
	do
		local A = track[1].pos
		local min={x=A.x, y=A.y, z=A.z}
		local max={x=A.x, y=A.y, z=A.z}
		for i=2,#track do
			local N = track[i].pos
			for key, value in pairs(max) do
				if N[key] > max[key] then max[key] = N[key] end
			end
			for key, value in pairs(max) do
				if N[key] < min[key] then min[key] = N[key] end
			end
		end
		track_bounds = {min=min, max=max}
	end

	track_bounds.center = {
		x=(track_bounds.min.x + track_bounds.max.x) / 2,
		y=(track_bounds.min.y + track_bounds.max.y) / 2,
		z=(track_bounds.min.z + track_bounds.max.z) / 2
	}
	local scale = 300000 + math.max(
			track_bounds.max.x - track_bounds.center.x,
			track_bounds.max.z - track_bounds.center.z
		)
CreateObject{
			name="Grid",
			gameobject={
				mesh="quad.obj",
				texture="2.jpg",
				texturewrap = "clamp",
				scale={scale,scale,scale},
				transform={
					pos={track_bounds.center.x, math.min(track_bounds.min.y - 10000, -40000), track_bounds.center.z},
					rot={-90,0,0}
				},
				shader="VertexColorUnlitTintedAddSmooth",
				layer=13, -- don't glow. in additive mode (above) glowing makes it reveal the pillars of light used to accent glow and skywires.
				shadercolors={
					_Color = {50,50,50}
				}
			}
		}

if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}

	for i=1,#track do
		if i%200==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end

		if (i+40)%200==0 then
			buildingNodesToo[#buildingNodesToo+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsetsToo[#offsetsToo+1] = {xOffset,-100,0}
		end
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=20,
                    		maxDistanceShown=2000,
							offsets=offsets,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}

	BatchRenderEveryFrame{prefabName="BuildingCloneMe2", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodesToo,
                    		rotateWithTrack=false,
                    		maxShown=20,
                    		maxDistanceShown=2000,
							offsets=offsetsToo,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}
						
end
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="zzzap",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="clock.obj",
		--shadowcaster=true,
		--layer = iflofi(13,18),
		shader="VertexColorUnlitTintedAddSmooth",
		shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
		texture="Bits0.png",
		--scale = {x=.45,y=.45,z=1}
	}
}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="zzzap1",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="clock.obj",
		--shadowcaster=true,
		--layer = iflofi(13,18),
		shader="VertexColorUnlitTintedAddSmooth",
		shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
		texture="Bits1.png",
		--scale = {x=.45,y=.45,z=1}
	}
}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="zzzap2",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="clock.obj",
		--shadowcaster=true,
		--layer = iflofi(13,18),
		shader="VertexColorUnlitTintedAddSmooth",
		shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
		texture="Bits2.png",
		--scale = {x=.45,y=.45,z=1}
	}
}
Nodes_Zone2 = {}
RotationSpeeds_Zone = {}
RotationSpeeds_Zone2 = {}
RotationSpeeds_Zone3 = {}
RotationSpeeds_Zone6 = {}
for i=1,#track do
			if track[i].intensity > 0.85 then
			Nodes_Zone2[#Nodes_Zone2+1] = i 
			RotationSpeeds_Zone[#RotationSpeeds_Zone+1] = {0,0,-100}
			RotationSpeeds_Zone2[#RotationSpeeds_Zone2+1] = {0,0,-300}
			RotationSpeeds_Zone3[#RotationSpeeds_Zone3+1] = {0,0,300}
			RotationSpeeds_Zone6[#RotationSpeeds_Zone6+1] = {0,0,200}
			end
end
BatchRenderEveryFrame{
	prefabName="zzzap", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = Scales,
	rotationspeeds = RotationSpeeds_Zone,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 3,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
BatchRenderEveryFrame{
	prefabName="zzzap2", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = Scales,
	rotationspeeds = RotationSpeeds_Zone6,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 2,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
BatchRenderEveryFrame{
	prefabName="zzzap1", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = Scales,
	rotationspeeds = RotationSpeeds_Zone2,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
BatchRenderEveryFrame{
	prefabName="zzzap1", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = Scales,
	rotationspeeds = RotationSpeeds_Zone3,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 4,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
Nodes_Zone1 = {}
Offsets_Zone1_alt = {}
RotationSpeeds_Zone1 = {}
Nodes_Zone1[#Nodes_Zone1+1] = #track
RotationSpeeds_Zone1[#RotationSpeeds_Zone1+1] = {0,0,200}
Offsets_Zone1_alt[#Offsets_Zone1_alt+1] = {0,0,10}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe3",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="end.obj",
		shader="RimLightHatched",
		shadercolors={
			_Color={0,0,0},
			_RimColor={1,1,1}
		}
	}
}
BatchRenderEveryFrame{
	prefabName="BuildingCloneMe3", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone1,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--scales = nil,
	rotationspeeds = RotationSpeeds_Zone1,
	offsets=Offsets_Zone1_alt,
	collisionLayer = 3,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}