tunnel_color_scale = 3,
SetTrackColors{
	{r=255, g=160, b=0}, -- orange (low intensity)
	{r=248, g=38, b=0}, -- red
	{r=174, g=0, b=255}, -- purple
	{r=0, g=127, b=255}, -- blue
	{r=134, g=201, b=255} -- bright blue (high intensity)
}
SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}
function fif(test, if_true, if_false) if test then return if_true else return if_false end end
skinvars = GetSkinProperties()
track_width = skinvars.trackwidth
track_height = 1.5 -- approximate top edge of standard blocks
if type(skinvars.trackheight) == "number" then track_height = skinvars.trackheight end
SetScene{
	glowpasses = 0,
	glowspread = 0,
	radialblur_strength = 0,
	airdebris_count = 0,
	airdebris_density = 0,
	water = false,
	towropes = false,
	useblackgrid = false
}
SetRings{
	size=0,
	airtexture="block.png",
	airsize=0
}
SetBlockFlashes{
	sizescaler = 0,
	sizescaler_missed = 0
}
SetWake{height=0}
	SetBlocks{
		colorblocks={
			height = 0.65,
			scale = {1,1,1},
			mesh = "block.obj",
		shader = "RimLight",
		texture = "block.png",
		},
		greyblocks={
			shadercolors= {_Color={50,50,50}},
			mesh = "block.obj",
		shader = "RimLight",
		texture = "block.png",
		},
	}
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
		camthird={
			pos={0,2,-0.5},
			rot={30,0,0},
			pos2={0,5,-4},
			rot2={30,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.65,
			puzzleoffset2=-1.5},
		vehicle={ --livecoding not supported here
			min_hover_height= 1.5,
			max_hover_height = 1.7, -- 0.75
			use_water_rooster = false,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},
			mesh="vehicle1a.obj",
			shader="VertexColorUnlitTinted",
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}},
			texture="vehicle1a_ao.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						extrusions=22,
						shader="VertexColorUnlitTintedAdd",
						stretch=-0.1191,
						updateseconds = 0.025,
						instances={
							{pos={0,.281,-1.33},rot={0,0,0},scale={1,1,1}},
							{pos={.1236,0.2,-1.297},rot={0,0,58.713},scale={.7,.7,.7}},
							{pos={-.1236,0.2,-1.297},rot={0,0,313.7366},scale={.7,.7,.7}}
						}}
		}
	}
function makeCylinder(radius, points, inside_out)
	local min, max, step
	if inside_out then min, max, step = 0, points-1, 1
	else min, max, step = points-1, 0, -1 end
	
	local shape = {}
	local pi2 = math.pi * 2
	for i=min,max,step do
		local angle = pi2 * (i/points)
		table.insert(shape, {radius * math.cos(angle), radius * math.sin(angle)})
	end
	return shape
end
do
	local track_corner_distance = math.sqrt(track_width^2 + track_height^2)
	local points = 64

		local colorScalers = {}
		for i=1,points do table.insert(colorScalers, tunnel_color_scale) end
		CreateRail{
			positionOffset = {0, 0},
			crossSectionShape = makeCylinder(track_corner_distance * 3, points, true),
			perShapeNodeColorScalers = colorScalers,
			wrapnodeshape = true,
			colorMode = "aurora",
			shader = "VertexColorUnlitTinted"
		}
end