
jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1, 2, or 3.
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

quality = GetQualityLevel4()
function ByQuality4(low,med,high,ultra)
	if quality < 2 then return low
	elseif quality <3 then return med
	elseif quality <4 then return high
	else return ultra end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
ispuzzle = skinvars.colorcount>1

SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
    skyscreen = "Skyscreen/TheGrid2D"
}

SetScene{
	glowpasses = ifhifi(4,2),
	glowspread = ifhifi(0.75,0.38),
	radialblur_strength = 0,
	water = false, --Only use the water cubes in wakeboard mode.
	towropes = false,--Use the tow ropes if jumping.
		airdebris_count = ifhifi(3000,500),
	airdebris_density = ifhifi(50,12),
	airdebris_particlesize = 1.9,
	airdebris_flashsizescaler = .2,
	airdebris_texture = "hit2.jpg",
	airdebris_layer = 12,
	useblackgrid=true,
	use_intro_swoop_cam = false,
	hide_default_background_verticals = true,
	--twistmode= {curvescaler=6.0,steepscaler=1.7}
}



SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
		{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
	}


SetBlocks{
		maxvisiblecount = 20,
		allow_mod_block_scaling = false,
		colorblocks={
			mesh = "PowerStar.obj",
				shader = "UnlitEdgedBlock",
				shadersettings={_Brightness=.5},
				texture = "Black.png",
				scale = {.9,.9,.9},
				layer=13,
				shadercolors = {_Color="highway"},
				reflect = false,
		    float_on_water = false,
		},
		greyblocks={
			mesh = "NewSpikeRot.obj",
			--mesh = "NewBlock.obj",
			reflect = false,
			shader = "VertexColorUnlitTinted",
			texture = "NewBlock.png",
			layer=13,
			float_on_water = false
		},
		powerups={--Override the following objects in case the mod uses them.
			powerpellet={
				mesh = "PowerStar.obj",
				shader = "UnlitEdgedBlock",
				shadersettings={_Brightness=.5},
				texture = "NewBlock.png",
				scale = {.9,.9,.9},
				layer=13,
				shadercolors = {_Color="highwayinverted", scaletype="intensity"},
				reflect = false
			},
			ghost={
				mesh = "PowerStar.obj",
				shader = "UnlitEdgedBlock",
				shadersettings={_Brightness=.5},
				texture = "NewBlock.png",
				scale = {1,1,1},
				layer=13,
				shadercolors = {_Color="highwayinverted", scaletype="intensity"},
				reflect = false
			},
		x2={
		mesh = "x2.obj",
				shader = "UnlitEdgedBlock",
				scale = {1.5,1.5,1.5},
				reflect = false},
		x3={
		mesh = "x3.obj",
				shader = "UnlitEdgedBlock",
				scale = {1.5,1.5,1.5},
				reflect = false},
		x4={
			mesh = "x4.obj",
				shader = "UnlitEdgedBlock",
				scale = {1.5,1.5,1.5},
				reflect = false}
		}
}
SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}
SetBlockFlashes{
	texture="White.png",
	sizescaler_missed = 0,
	sizescaler = 0
}

SetWake{ --Setup the spray coming from the two pulling "boats".
	height = 0,
}


SetRings{
	texture="White.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAddSmooth",
	size=0,
	percentringed=.2,
	airtexture="White.png",
	airshader="Unlit/Transparent",
	airsize=0,
	layer=13
}


	SetPlayer{
		cameramode = "third",
		cameradynamics = "low",
		camfirst={
			pos={0,0,0},
			rot={0,0,0}},
		camthird={
			pos={0,7,-7},
			rot={0,0,0},
			pos2={0,7,-7},
			rot2={0,0,0},
			
			strafefactor = 0,
			strafefactorFar = 0,
			transitionspeed = 3,
			puzzleoffset=0,
			puzzleoffset2=0},
		vehicle={
			min_hover_height= 2.5,
			max_hover_height = 2.5,
			use_water_rooster = false,
            smooth_tilting = false,
            rollscaler =0,
			panscaler = 0,
			mesh="2.obj",
		 
		shader = "MatCap/Vertex/PlainBright",
			shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
			textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
			layer = 15,
			reflect = false,
			renderqueue = 2000,
			scale = {x=.6,y=.6,z=.6},
		}
	}
CreateObject{
	name="Asriel",
	railoffset=0,
	tiltsmoother = 0,
	gameobject={
		transform={pos={0,0,70},rot={90,0,0}},
		mesh="quad.obj",
		shader = "Unlit/Transparent",
		texture="1.png",
		renderqueue=3000,
		scale = {x=80,y=1,z=80}
	}
}
rot1=math.random(0,359)
rot2=math.random(0,359)
rot3=math.random(0,359)
rot4=math.random(0,359)
rot5=math.random(0,359)
CreateObject{
	name="EndCookie1",
	railoffset=0,
	tiltsmoother = 0,
	gameobject={
		transform={pos={0,-5,70},rot={rot1,315,90},scale={scaletype="intensity",min={15,15,15},max={38,38,38}}},
		mesh="quad.obj",
		shader = "Unlit/Transparent",
		renderqueue=3002,
			texture = "higgs1.png",
	}
}
CreateObject{
	name="EndCookie2",
	railoffset=0,
	tiltsmoother = 0,
	gameobject={
		transform={pos={0,-5,70},rot={rot2,45,90},scale={scaletype="intensity",min={15,15,15},max={38,38,38}}},
		mesh="quad.obj",
		shader = "Unlit/Transparent",
		renderqueue=3002,
			texture = "higgs1.png",
	}
}
CreateObject{
	name="EndCookie3",
	railoffset=0,
	tiltsmoother = 0,
	gameobject={
		transform={pos={0,-5,70},rot={rot3,90,45},scale={scaletype="intensity",min={15,15,15},max={38,38,38}}},
		mesh="quad.obj",
		shader = "Unlit/Transparent",
		renderqueue=3002,
			texture = "higgs1.png",
	}
}
CreateObject{
	name="EndCookie4",
	railoffset=0,
	tiltsmoother = 0,
	gameobject={
		transform={pos={0,-5,70},rot={rot4,90,90},scale={scaletype="intensity",min={15,15,15},max={38,38,38}}},

		mesh="quad.obj",
		shader = "Unlit/Transparent",
		renderqueue=3002,
			texture = "higgs1.png",
	}
}
CreateObject{
	name="EndCookie5",
	railoffset=0,
	tiltsmoother = 0,
	gameobject={
		transform={pos={0,-5,70},rot={rot5,90,315},scale={scaletype="intensity",min={15,15,15},max={38,38,38}}},

		mesh="quad.obj",
		shader = "Unlit/Transparent",
		renderqueue=3002,
			texture = "higgs1.png",
	}
}
LoadSounds{
	--hit="hit.wav",
	hitgrey="Soul Hit.wav",
	trickfail="Soul Hit.wav",
	--matchsmall="matchsmall.wav",
	--matchmedium="matchmedium.wav",
	--matchlarge="matchlarge.wav",
	--matchhuge="matchhuge.wav",
	--overfillwarning="overfillwarning.wav"
}
CreateObject{
	name="lvf",
	railoffset=0,
	tiltsmoother = 0,
	--floatonwaterwaves = false,
	gameobject={
		pos={x=0,y=0,z=70},
		mesh="222.obj",
		--layer=10,
		shader="Unlit/Transparent",
texture = "black.png",
		scale = {x=80,y=80,z=80}
	}
}
 shaderset = {_Color = {colorsource="aurora", scaletype="intensity", minscaler=.7, maxscaler=.7}}
	auroraExtent = 3+trackWidth
	CreateRail{--left aurora
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=-auroraExtent,y=0},
			{x=0,y=0},
			{x=0,y=0},
			{x=-auroraExtent,y=0}},
		perShapeNodeColorScalers={
			0,
			1,
			1,
			0},
		colorMode="aurora",
		color = {r=200,g=200,b=200,a=155},
		flatten=false,
	    renderqueue=3001,
		texture="White.png",
		layer=14,
		shader="VertexColorUnlitTintedAddDouble",
		shadercolors=shaderset
	}

	CreateRail{--right aurora
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=0,y=0},
			{x=auroraExtent,y=0},
			{x=auroraExtent,y=0},
			{x=0,y=0}},
		perShapeNodeColorScalers={
			1,
			0,
			0,
			1},
		colorMode="aurora",
		color = {r=200,g=200,b=200,a=155},
		flatten=false,
		texture="White.png",
		layer=14,
		renderqueue=3001,
		shader="VertexColorUnlitTintedAddDouble",
		shadercolors=shaderset
	}	